Bug 1357110 - Review Request: foma - Xerox-compatible finite-state compiler
Summary: Review Request: foma - Xerox-compatible finite-state compiler
Keywords:
Status: POST
Alias: None
Product: Fedora
Classification: Fedora
Component: Package Review
Version: rawhide
Hardware: All
OS: Linux
medium
medium
Target Milestone: ---
Assignee: Robert-André Mauchin
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2016-07-15 19:02 UTC by Ville-Pekka Vainio
Modified: 2018-12-20 19:51 UTC (History)
2 users (show)

Fixed In Version:
Doc Type: If docs needed, set a value
Doc Text:
Clone Of:
Environment:
Last Closed: 2016-09-06 16:13:28 UTC
zebob.m: fedora-review+


Attachments (Terms of Use)

Description Ville-Pekka Vainio 2016-07-15 19:02:44 UTC
Spec URL: https://vpv.fedorapeople.org/packages/foma.spec
SRPM URL: https://vpv.fedorapeople.org/packages/foma-0.9.18-0.1.git0fa48db.fc25.src.rpm

Description: Foma can be used for constructing finite-state automata and transducers.
It has support for many natural language processing applications such as
producing morphological analyzers. It is sufficiently generic to use for
a large number of purposes in addition to NLP. The foma interface is
similar to the Xerox xfst interface.

Fedora Account System Username: vpv
Copr: https://copr.fedorainfracloud.org/coprs/vpv/Voikko-4.0/

Comment 1 Antonio 2016-07-16 12:25:46 UTC
Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed


Issues:
=======
- Package uses either %{buildroot} or $RPM_BUILD_ROOT
  Note: Using both %{buildroot} and $RPM_BUILD_ROOT
  See: http://fedoraproject.org/wiki/Packaging/Guidelines#macros

- Please, move following lines under %install section

sed -i '/^prefix/c\prefix = %{buildroot}%{_prefix}' foma/Makefile
sed -i '/^libdir/c\libdir = %{buildroot}%{_libdir}' foma/Makefile

- License file is installed by base package only.
  'foma' and 'libfoma-devel' require 'libfoma', 'COPYING' and 'README' files
  can be provided by 'libfoma' only.

- Libraries and binary files are "No Full Relro"
  Binary files are "No PIE"

Please, fix compiler/linker flags according to https://fedoraproject.org/wiki/Changes/Harden_All_Packages

- Fix the 'unused-direct-shlib-dependency' warnings
https://fedoraproject.org/wiki/Common_Rpmlint_issues?rd=PackageMaintainers/Common_Rpmlint_Issues#unused-direct-shlib-dependency

===== MUST items =====

C/C++:
[x]: Package does not contain kernel modules.
[x]: Package contains no static executables.
[x]: Header files in -devel subpackage, if present.
[x]: ldconfig called in %post and %postun if required.
[x]: Package does not contain any libtool archives (.la)
[x]: Rpath absent or only used for internal libs.
[x]: Development (unversioned) .so files in -devel subpackage, if present.

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses
     found: "Apache (v2.0)", "GPL (v2)", "Unknown or generated". 9 files
     have unknown license. Detailed output of licensecheck in
     /home/sagitter/1357110-foma/licensecheck.txt
[!]: License file installed when any subpackage combination is installed.
[!]: %build honors applicable compiler flags or justifies otherwise.
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[x]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: Useful -debuginfo package or justification otherwise.
[x]: Package is not known to require an ExcludeArch tag.
[-]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 10240 bytes in 1 files.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %license.
[x]: Package requires other packages for directories it uses.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: All build dependencies are listed in BuildRequires, except for any
     that are listed in the exceptions section of Packaging Guidelines.
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Dist tag is present.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

===== SHOULD items =====

Generic:
[-]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[x]: Fully versioned dependency in subpackages if applicable.
     Note: No Requires: %{name}%{?_isa} = %{version}-%{release} in libfoma
     , foma-debuginfo
[ ]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[x]: Scriptlets must be sane, if used.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[-]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed
     files.
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on debuginfo package(s).
     Note: No rpmlint messages.
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Large data in /usr/share should live in a noarch subpackage if package
     is arched.
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: foma-0.9.18-0.1.git0fa48db.fc25.i686.rpm
          libfoma-0.9.18-0.1.git0fa48db.fc25.i686.rpm
          libfoma-devel-0.9.18-0.1.git0fa48db.fc25.i686.rpm
          foma-debuginfo-0.9.18-0.1.git0fa48db.fc25.i686.rpm
          foma-0.9.18-0.1.git0fa48db.fc25.src.rpm
foma.i686: W: spelling-error %description -l en_US automata -> automate, automaton, automatism
foma.i686: W: spelling-error %description -l en_US xfst -> fist
foma.i686: W: no-manual-page-for-binary flookup
foma.i686: W: no-manual-page-for-binary cgflookup
foma.i686: W: no-manual-page-for-binary foma
libfoma.i686: W: spelling-error Summary(en_US) foma -> foam, fora, coma
libfoma.i686: W: spelling-error %description -l en_US Foma -> Coma, Foam, Fora
libfoma.i686: W: spelling-error %description -l en_US automata -> automate, automaton, automatism
libfoma.i686: W: spelling-error %description -l en_US foma -> foam, fora, coma
libfoma.i686: W: spelling-error %description -l en_US xfst -> fist
libfoma.i686: W: shared-lib-calls-exit /usr/lib/libfoma.so.0.9.18 exit@GLIBC_2.0
libfoma.i686: W: no-documentation
libfoma-devel.i686: W: no-documentation
foma.src: W: spelling-error %description -l en_US automata -> automate, automaton, automatism
foma.src: W: spelling-error %description -l en_US xfst -> fist
foma.src:64: W: rpm-buildroot-usage %build sed -i '/^prefix/c\prefix = %{buildroot}%{_prefix}' foma/Makefile
foma.src:65: W: rpm-buildroot-usage %build sed -i '/^libdir/c\libdir = %{buildroot}%{_libdir}' foma/Makefile
5 packages and 0 specfiles checked; 0 errors, 17 warnings.




Rpmlint (debuginfo)
-------------------
Checking: foma-debuginfo-0.9.18-0.1.git0fa48db.fc25.i686.rpm
1 packages and 0 specfiles checked; 0 errors, 0 warnings.





Rpmlint (installed packages)
----------------------------
foma.i686: W: spelling-error %description -l en_US automata -> automate, automaton, automatic
foma.i686: W: spelling-error %description -l en_US xfst -> fist
foma.i686: W: no-manual-page-for-binary foma
foma.i686: W: no-manual-page-for-binary flookup
foma.i686: W: no-manual-page-for-binary cgflookup
libfoma.i686: W: spelling-error Summary(en_US) foma -> foam, fora, coma
libfoma.i686: W: spelling-error %description -l en_US Foma -> Coma, Foam, Fora
libfoma.i686: W: spelling-error %description -l en_US automata -> automate, automaton, automatic
libfoma.i686: W: spelling-error %description -l en_US foma -> foam, fora, coma
libfoma.i686: W: spelling-error %description -l en_US xfst -> fist
libfoma.i686: W: unused-direct-shlib-dependency /usr/lib/libfoma.so.0.9.18 /lib/libreadline.so.6
libfoma.i686: W: unused-direct-shlib-dependency /usr/lib/libfoma.so.0.9.18 /lib/libtinfo.so.6
libfoma.i686: W: shared-lib-calls-exit /usr/lib/libfoma.so.0.9.18 exit@GLIBC_2.0
libfoma.i686: W: no-documentation
libfoma-devel.i686: W: no-documentation
4 packages and 0 specfiles checked; 0 errors, 15 warnings.



Requires
--------
foma (rpmlib, GLIBC filtered):
    libc.so.6
    libfoma(x86-32)
    libreadline.so.6
    libtinfo.so.6
    libz.so.1
    libz.so.1(ZLIB_1.2.2.3)
    rtld(GNU_HASH)

libfoma (rpmlib, GLIBC filtered):
    /sbin/ldconfig
    libc.so.6
    libreadline.so.6
    libtinfo.so.6
    libz.so.1
    libz.so.1(ZLIB_1.2.2.3)
    rtld(GNU_HASH)

libfoma-devel (rpmlib, GLIBC filtered):
    libfoma(x86-32)
    libfoma.so.0

foma-debuginfo (rpmlib, GLIBC filtered):



Provides
--------
foma:
    foma
    foma(x86-32)

libfoma:
    libfoma
    libfoma(x86-32)
    libfoma.so.0

libfoma-devel:
    libfoma-devel
    libfoma-devel(x86-32)

foma-debuginfo:
    foma-debuginfo
    foma-debuginfo(x86-32)



Source checksums
----------------
https://github.com/mhulden/foma/archive/0fa48dbacfe39509577ae6741054be7c05a19aac.tar.gz#/foma-0fa48db.tar.gz :
  CHECKSUM(SHA256) this package     : f0c15f2338865ec515ee0cf8b460bc22fad3e7bdbd84a430c1be25889bd9673c
  CHECKSUM(SHA256) upstream package : f0c15f2338865ec515ee0cf8b460bc22fad3e7bdbd84a430c1be25889bd9673c


Generated by fedora-review 0.6.1 (f03e4e7) last change: 2016-05-02
Command line :/usr/bin/fedora-review -m fedora-rawhide-i386 -b 1357110
Buildroot used: fedora-rawhide-i386
Active plugins: Generic, Shell-api, C/C++
Disabled plugins: Java, Python, fonts, SugarActivity, Ocaml, Perl, Haskell, R, PHP
Disabled flags: EXARCH, DISTTAG, EPEL5, BATCH, EPEL6

Comment 2 Ville-Pekka Vainio 2018-08-11 17:29:47 UTC
It's been two years, but I'm back attempting to package foma. I believe I've addressed all of the issues pointed out in the review.

The new packages are here:
https://vpv.fedorapeople.org/packages/foma-2018/foma.spec
https://vpv.fedorapeople.org/packages/foma-2018/foma-0.9.18-0.1.git0fa48db.fc29.src.rpm

Comment 3 Ville-Pekka Vainio 2018-08-12 08:50:29 UTC
Reopening the report. Antonio, are you still interested in reviewing this one?

Comment 4 Robert-André Mauchin 2018-08-12 13:48:39 UTC
 - 
%post -n %{libname} -p /sbin/ldconfig
%postun -n %{libname} -p /sbin/ldconfig


This is not needed starting Fedora 28. Either remove it or use %ldconfig_scriptlets -n %{libname} if youplan to support F27.

 - %{_libdir}/%{libname}.so.*

New rule: don't glob the major soname version in order to avoid unintentional soname bump (https://pagure.io/packaging-committee/issue/784)

 - Also replace the LDFLAGS with Fedora ones in foma/Makefile (%__global_ldflags)

Comment 5 Ville-Pekka Vainio 2018-08-26 17:52:01 UTC
- ldconfig calls removed, I only plan to have this in F28+
- soname globbing removed
- I used %{build_ldflags} as per https://src.fedoraproject.org/rpms/redhat-rpm-config/blob/master/f/buildflags.md

- Had some linking issues when working on the changes, but maybe I just had a typo in the spec, the package seems to link now.

SPEC: https://vpv.fedorapeople.org/packages/foma-2018/foma.spec
SRPM: https://vpv.fedorapeople.org/packages/foma-2018/foma-0.9.18-0.1.git0fa48db.fc30.src.rpm

Comment 6 Robert-André Mauchin 2018-08-26 21:04:38 UTC
 - Since you're packaging a dev snapshot you must include the snapshot date en Release:


%global commit0 0fa48dbacfe39509577ae6741054be7c05a19aac
%global shortcommit0 %(c=%{commit0}; echo ${c:0:7})
%global snapshotdate 20180826

%global libname libfoma

Name:           foma
Version:        0.9.18
Release:        0.1.%{snapshotdate}git%{shortcommit0}%{?dist}


 - Group: shouldn't be used in Fedora



Package otherwise approved. Please fix the above issues before import.


Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed



===== MUST items =====

C/C++:
[x]: Package does not contain kernel modules.
[x]: Package contains no static executables.
[x]: If your application is a C or C++ application you must list a
     BuildRequires against gcc, gcc-c++ or clang.
[x]: Header files in -devel subpackage, if present.
[x]: ldconfig not called in %post and %postun for Fedora 28 and later.
[x]: Package does not contain any libtool archives (.la)
[x]: Rpath absent or only used for internal libs.
[x]: Development (unversioned) .so files in -devel subpackage, if present.

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses
     found: "Apache (v2.0)", "*No copyright* Apache (v2)", "GPL (v2)",
     "Unknown or generated", "*No copyright* Apache (v2.0)". 11 files have
     unknown license. Detailed output of licensecheck in
     /home/bob/packaging/review/foma/review-foma/licensecheck.txt
[x]: License file installed when any subpackage combination is installed.
[x]: %build honors applicable compiler flags or justifies otherwise.
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[x]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: Useful -debuginfo package or justification otherwise.
[x]: Package is not known to require an ExcludeArch tag.
[-]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 10240 bytes in 1 files.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %license.
[x]: Package requires other packages for directories it uses.
[x]: Package does not own files or directories owned by other packages.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Dist tag is present.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

===== SHOULD items =====

Generic:
[-]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[x]: Fully versioned dependency in subpackages if applicable.
     Note: No Requires: %{name}%{?_isa} = %{version}-%{release} in libfoma
     , foma-debuginfo , foma-debugsource
[?]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[x]: Patches link to upstream bugs/comments/lists or are otherwise
     justified.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[-]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed
     files.
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on debuginfo package(s).
     Note: There are rpmlint messages (see attachment).
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Large data in /usr/share should live in a noarch subpackage if package
     is arched.
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: foma-0.9.18-0.1.git0fa48db.fc30.x86_64.rpm
          libfoma-0.9.18-0.1.git0fa48db.fc30.x86_64.rpm
          libfoma-devel-0.9.18-0.1.git0fa48db.fc30.x86_64.rpm
          foma-debuginfo-0.9.18-0.1.git0fa48db.fc30.x86_64.rpm
          foma-debugsource-0.9.18-0.1.git0fa48db.fc30.x86_64.rpm
          foma-0.9.18-0.1.git0fa48db.fc30.src.rpm
foma.x86_64: W: spelling-error %description -l en_US automata -> automate, automaton, automatism
foma.x86_64: W: spelling-error %description -l en_US xfst -> fist
foma.x86_64: W: no-documentation
foma.x86_64: W: no-manual-page-for-binary cgflookup
foma.x86_64: W: no-manual-page-for-binary flookup
foma.x86_64: W: no-manual-page-for-binary foma
libfoma.x86_64: W: spelling-error Summary(en_US) foma -> foam, fora, coma
libfoma.x86_64: W: spelling-error %description -l en_US Foma -> Coma, Foam, Fora
libfoma.x86_64: W: spelling-error %description -l en_US automata -> automate, automaton, automatism
libfoma.x86_64: W: spelling-error %description -l en_US foma -> foam, fora, coma
libfoma.x86_64: W: spelling-error %description -l en_US xfst -> fist
libfoma.x86_64: W: shared-lib-calls-exit /usr/lib64/libfoma.so.0.9.18 exit@GLIBC_2.2.5
libfoma-devel.x86_64: W: no-documentation
foma.src: W: spelling-error %description -l en_US automata -> automate, automaton, automatism
foma.src: W: spelling-error %description -l en_US xfst -> fist
6 packages and 0 specfiles checked; 0 errors, 15 warnings.

Comment 7 Ville-Pekka Vainio 2018-09-11 17:56:00 UTC
Thank you, Robert-André!
I've had a few busy weeks, I plan on finishing the packaging next weekend.

Comment 8 Ville-Pekka Vainio 2018-09-16 16:11:33 UTC
SPEC: https://vpv.fedorapeople.org/packages/foma-2018/foma.spec
SRPM: https://vpv.fedorapeople.org/packages/foma-2018/foma-0.9.18-0.1.20150613git0fa48db.fc29.src.rpm

I used the git commit date as the snapshot date, I think it's more informative to the users of the package. Will request the git module and branches now.

Comment 9 Gwyn Ciesla 2018-09-16 21:52:54 UTC
(fedscm-admin):  The Pagure repository was created at https://src.fedoraproject.org/rpms/foma


Note You need to log in before you can comment on or make changes to this bug.